diff -Nur dovecot/src/lib-index/mbox/mbox-rewrite.c dovecot-idx/src/lib-index/mbox/mbox-rewrite.c
--- dovecot/src/lib-index/mbox/mbox-rewrite.c	Sun Oct  5 19:54:19 2003
+++ dovecot-idx/src/lib-index/mbox/mbox-rewrite.c	Tue Nov  4 18:00:28 2003
@@ -769,6 +769,8 @@
 		}
 	}
 
+        index->set_flags |= MAIL_INDEX_HDR_FLAG_REBUILD;
+
 	if (!failed) {
 		if (!reset_dirty_flags(index))
 			failed = TRUE;
diff -Nur dovecot/src/lib-index/mbox/mbox-sync.c dovecot-idx/src/lib-index/mbox/mbox-sync.c
--- dovecot/src/lib-index/mbox/mbox-sync.c	Wed Oct 29 16:45:41 2003
+++ dovecot-idx/src/lib-index/mbox/mbox-sync.c	Tue Nov  4 18:01:00 2003
@@ -96,6 +96,7 @@
 
 		if ((index->set_flags & MAIL_INDEX_HDR_FLAG_REBUILD) != 0) {
 			/* uidvalidity probably changed, rebuild */
+			index->set_flags &= ~MAIL_INDEX_HDR_FLAG_REBUILD;
 			if (!index->rebuild(index))
 				return FALSE;
 		}